/*************************************************************/
/* Copyright (C) 2014 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Fri Oct 24 11:04:37 2014 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-2014.10.24.11.04.02.448/oss774666001643395568gen/LibItsDenm_asn1.gen
 * asn/DENM.asn asn/ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type AlacarteContainer from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class AlacarteContainer extends Sequence {
    
    /**
     * The default constructor.
     */
    public AlacarteContainer()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public AlacarteContainer(ImpactReductionContainer impactReduction, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Temperature externalTemperature, 
		    RoadWorksContainerExtended roadWorks, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.PositioningSolutionType positioningSolution, 
		    StationaryVehicleContainer stationaryVehicle)
    {
	setImpactReduction(impactReduction);
	setExternalTemperature(externalTemperature);
	setRoadWorks(roadWorks);
	setPositioningSolution(positioningSolution);
	setStationaryVehicle(stationaryVehicle);
    }
    
    public void initComponents()
    {
	mComponents[0] = new ImpactReductionContainer();
	mComponents[1] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Temperature();
	mComponents[2] = new RoadWorksContainerExtended();
	mComponents[3] = org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.PositioningSolutionType.noPositioningSolution;
	mComponents[4] = new StationaryVehicleContainer();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[5];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new ImpactReductionContainer();
	    case 1:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Temperature();
	    case 2:
		return new RoadWorksContainerExtended();
	    case 3:
		return org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.PositioningSolutionType.noPositioningSolution;
	    case 4:
		return new StationaryVehicleContainer();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "impactReduction"
    public ImpactReductionContainer getImpactReduction()
    {
	return (ImpactReductionContainer)mComponents[0];
    }
    
    public void setImpactReduction(ImpactReductionContainer impactReduction)
    {
	mComponents[0] = impactReduction;
    }
    
    public boolean hasImpactReduction()
    {
	return componentIsPresent(0);
    }
    
    public void deleteImpactReduction()
    {
	setComponentAbsent(0);
    }
    
    
    // Methods for field "externalTemperature"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Temperature getExternalTemperature()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Temperature)mComponents[1];
    }
    
    public void setExternalTemperature(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Temperature externalTemperature)
    {
	mComponents[1] = externalTemperature;
    }
    
    public boolean hasExternalTemperature()
    {
	return componentIsPresent(1);
    }
    
    public void deleteExternalTemperature()
    {
	setComponentAbsent(1);
    }
    
    
    // Methods for field "roadWorks"
    public RoadWorksContainerExtended getRoadWorks()
    {
	return (RoadWorksContainerExtended)mComponents[2];
    }
    
    public void setRoadWorks(RoadWorksContainerExtended roadWorks)
    {
	mComponents[2] = roadWorks;
    }
    
    public boolean hasRoadWorks()
    {
	return componentIsPresent(2);
    }
    
    public void deleteRoadWorks()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "positioningSolution"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.PositioningSolutionType getPositioningSolution()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.PositioningSolutionType)mComponents[3];
    }
    
    public void setPositioningSolution(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.PositioningSolutionType positioningSolution)
    {
	mComponents[3] = positioningSolution;
    }
    
    public boolean hasPositioningSolution()
    {
	return componentIsPresent(3);
    }
    
    public void deletePositioningSolution()
    {
	setComponentAbsent(3);
    }
    
    
    // Methods for field "stationaryVehicle"
    public StationaryVehicleContainer getStationaryVehicle()
    {
	return (StationaryVehicleContainer)mComponents[4];
    }
    
    public void setStationaryVehicle(StationaryVehicleContainer stationaryVehicle)
    {
	mComponents[4] = stationaryVehicle;
    }
    
    public boolean hasStationaryVehicle()
    {
	return componentIsPresent(4);
    }
    
    public void deleteStationaryVehicle()
    {
	setComponentAbsent(4);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "AlacarteContainer"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "AlacarteContainer"
	),
	12318,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"ImpactReductionContainer"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"ImpactReductionContainer"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "ImpactReductionContainer"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "ImpactReductionContainer"
				)
			    ),
			    0
			)
		    ),
		    "impactReduction",
		    0,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"Temperature"
			    ),
			    new QName (
				"ITS-Container",
				"Temperature"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Temperature(-60), 
				    new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Temperature(67),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-60),
				new java.lang.Long(67)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"equalOrSmallerThanMinus60Deg",
					-60
				    ),
				    new MemberListElement (
					"oneDegreeCelsius",
					1
				    ),
				    new MemberListElement (
					"equalOrGreaterThan67Deg",
					67
				    )
				}
			    )
			)
		    ),
		    "externalTemperature",
		    1,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"RoadWorksContainerExtended"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"RoadWorksContainerExtended"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "RoadWorksContainerExtended"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "RoadWorksContainerExtended"
				)
			    ),
			    0
			)
		    ),
		    "roadWorks",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"PositioningSolutionType"
			    ),
			    new QName (
				"ITS-Container",
				"PositioningSolutionType"
			    ),
			    12318,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"noPositioningSolution",
					0
				    ),
				    new MemberListElement (
					"sGNSS",
					1
				    ),
				    new MemberListElement (
					"dGNSS",
					2
				    ),
				    new MemberListElement (
					"sGNSSplusDR",
					3
				    ),
				    new MemberListElement (
					"dGNSSplusDR",
					4
				    ),
				    new MemberListElement (
					"dR",
					5
				    )
				}
			    ),
			    0,
			    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.PositioningSolutionType.noPositioningSolution
			)
		    ),
		    "positioningSolution",
		    3,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8004
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"StationaryVehicleContainer"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"StationaryVehicleContainer"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "StationaryVehicleContainer"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "StationaryVehicleContainer"
				)
			    ),
			    0
			)
		    ),
		    "stationaryVehicle",
		    4,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0),
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' AlacarteContainer object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' AlacarteContainer object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for AlacarteContainer
